import * as i0 from '@angular/core';
import { Component, ChangeDetectionStrategy, Input, NgModule } from '@angular/core';
import * as i1 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i2 from '@angular/material/progress-spinner';
import { MatProgressSpinnerModule } from '@angular/material/progress-spinner';

class MxLoadingComponent {
    constructor(cd) {
        this.cd = cd;
        this.title = '';
        this.show = true;
        this.isTransparent = false;
        this.isComponent = false;
        this.loadingDelay = false;
    }
    ngOnChanges(changes) {
        // every time the object changes
        // store the new `title`
        this.titleOld = this.title;
    }
    ngDoCheck() {
        // check for object mutation
        if (this.titleOld !== this.title) {
            this.cd.markForCheck();
        }
    }
    start() {
        if (!this.show) {
            this.show = true;
            this.loadingDelay = true;
            this.cd.markForCheck();
            setTimeout(() => {
                this.loadingDelay = false;
                this.cd.markForCheck();
            }, 300);
        }
    }
    complete() {
        this.show = false;
        this.loadingDelay = false;
        this.cd.markForCheck();
    }
}
MxLoadingComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: MxLoadingComponent, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component });
MxLoadingComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.12", type: MxLoadingComponent, selector: "mx-loading", inputs: { title: "title", show: "show", isTransparent: "isTransparent", isComponent: "isComponent" }, usesOnChanges: true, ngImport: i0, template: `
    <div id="loading"
      [style.display]="show ? 'block' : 'none'">
      <div class="loading-overlay" [ngClass]="{'loading-overlay-transparent': loadingDelay}"
        [style.position]="isComponent ? 'absolute': 'fixed'">
      </div>
      <div *ngIf="!loadingDelay" class="progress-container" [style.position]="isComponent ? 'absolute': 'fixed'">
        <mat-progress-spinner class="progress-spinner" mode="indeterminate"></mat-progress-spinner>
        <div id="title" class="title">{{ title }}</div>
      </div>
    </div>
    `, isInline: true, styles: [".title{display:inline-block;margin-top:10px;max-width:600px;white-space:pre-wrap;white-space:-moz-pre-wrap;white-space:-pre-wrap;white-space:-o-pre-wrap;word-wrap:break-word;background-color:#fff9;box-shadow:0 0 10px #fff}.loading-overlay{position:fixed;width:100%;height:100%;top:0;left:0;z-index:1003;background:#f7f7f7;opacity:.65}.loading-overlay-transparent{opacity:0}.progress-container{z-index:1003;top:50%;left:50%;transform:translate(-50%,-50%);text-align:center}.progress-spinner{margin:0 auto}\n"], dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: i2.MatProgressSpinner, selector: "mat-progress-spinner, mat-spinner", inputs: ["color", "diameter", "strokeWidth", "mode", "value"], exportAs: ["matProgressSpinner"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: MxLoadingComponent, decorators: [{
            type: Component,
            args: [{ changeDetection: ChangeDetectionStrategy.OnPush, selector: 'mx-loading', template: `
    <div id="loading"
      [style.display]="show ? 'block' : 'none'">
      <div class="loading-overlay" [ngClass]="{'loading-overlay-transparent': loadingDelay}"
        [style.position]="isComponent ? 'absolute': 'fixed'">
      </div>
      <div *ngIf="!loadingDelay" class="progress-container" [style.position]="isComponent ? 'absolute': 'fixed'">
        <mat-progress-spinner class="progress-spinner" mode="indeterminate"></mat-progress-spinner>
        <div id="title" class="title">{{ title }}</div>
      </div>
    </div>
    `, styles: [".title{display:inline-block;margin-top:10px;max-width:600px;white-space:pre-wrap;white-space:-moz-pre-wrap;white-space:-pre-wrap;white-space:-o-pre-wrap;word-wrap:break-word;background-color:#fff9;box-shadow:0 0 10px #fff}.loading-overlay{position:fixed;width:100%;height:100%;top:0;left:0;z-index:1003;background:#f7f7f7;opacity:.65}.loading-overlay-transparent{opacity:0}.progress-container{z-index:1003;top:50%;left:50%;transform:translate(-50%,-50%);text-align:center}.progress-spinner{margin:0 auto}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }]; }, propDecorators: { title: [{
                type: Input
            }], show: [{
                type: Input
            }], isTransparent: [{
                type: Input
            }], isComponent: [{
                type: Input
            }] } });

class MxLoadingModule {
}
MxLoadingModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: MxLoadingModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
MxLoadingModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.2.12", ngImport: i0, type: MxLoadingModule, declarations: [MxLoadingComponent], imports: [CommonModule,
        MatProgressSpinnerModule], exports: [MxLoadingComponent] });
MxLoadingModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: MxLoadingModule, imports: [CommonModule,
        MatProgressSpinnerModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: MxLoadingModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        MatProgressSpinnerModule
                    ],
                    declarations: [MxLoadingComponent],
                    exports: [MxLoadingComponent]
                }]
        }] });

/*
 * Public API Surface of mx-loading
 */

/**
 * Generated bundle index. Do not edit.
 */

export { MxLoadingComponent, MxLoadingModule };
//# sourceMappingURL=mx-loading.mjs.map
